// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/@types/jasmine/index.d.ts" />

import { Result } from "../../src/util/result";
import { PabDimension, PabDimensionParams } from "../../src/pab/pab_dimension";
import { checkResult } from "../test_func";

function pabDimensionTest(varTest: string) {
    describe("Calc(): ", () => {
        it("V should be 1", () => {
            const prms = new PabDimensionParams(
                4,      // Longueur L
                1,      // Largeur W
                0.5,    // Tirant d'eau Y
                2       // Volume V
            );

            let res: number = prms[varTest].v;

            const nub = new PabDimension(prms);
            prms[varTest].v = undefined;

            checkResult(nub.Calc(varTest), res);
        });
    });
}

describe("Class PabDimension: ", () => {
    // beforeEach(() => {
    // });
    // beforeAll(() => {
    // });
    pabDimensionTest("L");
    pabDimensionTest("W");
    pabDimensionTest("Y");
    pabDimensionTest("V");

});
