/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 */
// import { describe, expect, it, xdescribe } from "../mock_jasmine";

import { RectangularStructure } from "../../src/structure/rectangular_structure";
import { StructureFlowMode, StructureFlowRegime } from "../../src/structure/structure";
import { Result } from "../../src/util/result";
import { precDigits } from "../test_config";

/**
 * Récupération du nom de la classe
 * https://www.stevefenton.co.uk/2013/04/Obtaining-A-Class-Name-At-Runtime-In-TypeScript/
 */
export class Describer {
    /**
     * Récupère le nom de la classe d'un objet
     * @param inputClass Objet à tester
     */
    public static getName(inputClass: any) {
        const funcNameRegex = /function (.{1,})\(/;
        const results = (funcNameRegex).exec((inputClass as any).constructor.toString());
        return (results && results.length > 1) ? results[1] : "";
    }
}

export function itCalcQ(
    struct: RectangularStructure, Z1: number, W: number, Q: number,
    mode?: StructureFlowMode, regime?: StructureFlowRegime) {

    struct.debug("itCalQ " + Describer.getName(struct) + " Z1=" + Z1 + " W=" + W + " Q=" + Q);

    struct.prms.Z1.v = Z1;
    struct.prms.W.v = W;
    const res: Result = struct.Calc("Q");
    struct.debug("struct.Calc(Q)=" + res.vCalc);

    it("Q(Z1=" + Z1 + ",W=" + W + ") should be " + Q, () => {
        struct.debug("struct.Calc(Q)=" + res.vCalc);
        expect(res.vCalc).toBeCloseTo(Q, precDigits);
    });
    if (mode !== undefined) {
        it("Q(Z1=" + Z1 + ",W=" + W + ") Mode should be " + mode, () => {
            expect(res.extraResults.Mode).toBe(mode);
        });
    }
    if (regime !== undefined) {
        it("Q(Z1=" + Z1 + ",W=" + W + ") Regime should be " + regime, () => {
            expect(res.extraResults.Regime).toBe(regime);
        });
    }
}
