export class ArrayReverseIterator<T> implements IterableIterator<T> {
    private _index: number;

    constructor(private _arr: any[]) {
        this._index = this._arr == undefined ? 0 : this._arr.length - 1;
    }

    public next(): IteratorResult<T> {
        if (this._arr != undefined && this._index >= 0) {
            return {
                done: false,
                value: this._arr[this._index--]
            }
        } else {
            return {
                done: true,
                value: null
            }
        }
    }

    [Symbol.iterator](): IterableIterator<T> {
        return this;
    }
}
